class Controller {
  constructor() {
    // TODO
  }

  async connect(host = '0.0.0.0', port = 9800) {
    const url = this.apiURL('/api/connect', {
      host,
      port
    })

    const response = await fetch(url)
    const data = await response.json()

    return data.success
  }

  async getSoundfonts() {
    const url = this.apiURL('/api/soundfonts')

    const response = await fetch(url)

    return response.json()
  }

  async getInstruments(font) {
    const url = this.apiURL('/api/instruments', {
      font
    })

    const response = await fetch(url)

    return response.json()
  }

  async select({channel, instrument, bank, program}) {
    const url = this.apiURL('/api/select', {channel, instrument, bank, program})
    const response = await fetch(url)
    const data = response.json()

    return data.success
  }

  // Private

  apiURL(path, params = {}) {
    const url = new URL(document.location)
    url.pathname = path
    url.hash = ''

    for (let [key, value] of Object.entries(params)) {
      url.searchParams.append(key, value)
    }

    return url
  }
}

const controller = new Controller()

export default controller
